# ansible-playbook-2.9 playbooks/bluecoat_upgrade.yml -i host_vars/rps.yml -e "rps_group=rps-[wind|betz]" -e "port=8090" -e "sgos=6.7.5.22"

---
- name: Upgrade RPS
  hosts: "{{ rps_group | default('localhost') }}"
  serial: "{{ batch_size | default(3) }}"
  gather_facts: false
  vars:
    sgos: "{{ sgos }}"

  tasks:

    - name: Set provider Lab
      ansible.builtin.set_fact:
        provider:
          host: "{{ inventory_hostname }}"
          port: "{{ port }}"
          user: "{{ rps_lab_username }}"
          password: "{{ rps_lab_pwd }}"
      when: "inventory_hostname is search(\"ps-lab\")"

    - name: Set provider Prod
      ansible.builtin.set_fact:
        provider:
          host: "{{ inventory_hostname }}-mgt"
          port: "{{ port }}"
          user: "{{ rps_username }}"
          password: "{{ rps_pwd }}"
      when: "inventory_hostname is not search(\"ps-lab\")"

    - name: Check current version
      sgos.sgos_command.sgos_command:
        provider: "{{ provider }}"
        cmd: |
          show status
      register: sgos_cmd
      delegate_to: "{{ delegate_host }}"

    - name: Looking for SGOS verion
      ansible.builtin.set_fact:
        version: "{{ sgos_cmd.original_message | regex_search('Software version:.*SG\\s(.*)', '\\1') | first }}"
      delegate_to: "{{ delegate_host }}"

    - name: Message for current version
      ansible.builtin.debug:
        msg: "Current version is {{ version }}"
      delegate_to: "{{ delegate_host }}"

    - name: Stop Playbook
      ansible.builtin.debug:
        msg: "SGOS {{ sgos }} is already the running version on device {{ inventory_hostname }}"
      when: version == sgos
      delegate_to: "{{ delegate_host }}"

    - name: Stop Playbook
      ansible.builtin.meta: end_host
      when: version == sgos

    - name: Remove device from Pool
      sgos.sgos_command.sgos_command:
        provider: "{{ provider }}"
        cmd: |
          health-check
          disable sick user.HC-GLOBAL
      register: sgos_cmd
      delegate_to: "{{ delegate_host }}"

    - name: Upgrade
      ansible.builtin.include_tasks: ../tasks/bluecoat_upgrade_AWX.yml

    - name: Show status after reboot
      sgos.sgos_command.sgos_command:
        provider: "{{ provider }}"
        cmd: |
          show status
      register: sgos_cmd
      delegate_to: "{{ delegate_host }}"

    - name: Looking for SGOS verion
      ansible.builtin.set_fact:
        version: "{{ sgos_cmd.original_message | regex_search('Software version:.*SG\\s(.*)', '\\1') | first }}"
      delegate_to: "{{ delegate_host }}"

    - name: Message for current version
      ansible.builtin.debug:
        msg: "Current version is {{ version }}"
      delegate_to: "{{ delegate_host }}"

    - name: Message if current version is not the new one
      ansible.builtin.fail:
        msg: "Current version is {{ version }} instead of {{ sgos }}"
      when: version != sgos
      delegate_to: "{{ delegate_host }}"

    - name: Wait for HTTPS service
      ansible.builtin.wait_for:
        host: "{{ inventory_hostname }}-mgt.snmc.cec.eu.int"
        port: "443"
        delay: 5
        connect_timeout: 10
        timeout: 600
      delegate_to: "{{ delegate_host }}"
      when: "inventory_hostname is not search(\"ps-lab\")"

    - name: Paus playbook for 1 minute
      ansible.builtin.pause:
        minutes: 1
      when: "inventory_hostname is search(\"ps-lab\")"

    - name: Add device in Pool
      sgos.sgos_command.sgos_command:
        provider: "{{ provider }}"
        cmd: |
          health-check
          disable healthy user.HC-GLOBAL
      register: sgos_cmd
      delegate_to: "{{ delegate_host }}"

    - name: Look for device in Pool
      sgos.sgos_command.sgos_command:
        provider: "{{ provider }}"
        cmd: |
          health-check
          view quick-statistics
      register: sgos_cmd
      delegate_to: "{{ delegate_host }}"

    - name: Check for device in Pool
      ansible.builtin.set_fact:
        pool: "{{ sgos_cmd.original_message | regex_search('user.HC-GLOBAL.*') }}"
      delegate_to: "{{ delegate_host }}"

    - name: Message for device in Pool
      ansible.builtin.debug:
        msg: "Device {{ inventory_hostname }} came back to the pool"
      when: pool is search("UP")
      delegate_to: "{{ delegate_host }}"

    - name: Message for device not in Pool
      ansible.builtin.debug:
        msg: "Device {{ inventory_hostname }} is not came back to the pool"
      when: pool is search("DOWN")
      delegate_to: "{{ delegate_host }}"
